<?php 
    require_once('../library/autoload.php');
    require_once('../common/__config.php');
    
    if ( !defined( 'CONVO_BASE_URL')) {
        throw new \Exception( 'CONVO_BASE_URL is not defined!');
    }
    
    if ( !defined( 'CONVO_PUBLIC_REST_BASE_URL')) {
        define( 'CONVO_PUBLIC_REST_BASE_URL', CONVO_BASE_URL.'/rest_public/convo/v1');
    }
    
    if ( !defined( 'PROTO_DEMO_SERVICE')) {
        define( 'PROTO_DEMO_SERVICE', '');
    }

?>

<!DOCTYPE html>
<html lang="en" ng-app="proto.admin" style="font-size: 16px;">

    <head>
        <meta name="robots" content="noindex">
        <meta charset="utf-8">
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
		<meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=no">
        <title><?php echo PROTO_APP_TITLE ?></title>


 <script type="text/javascript" src="./vendor.js?3d7b071c86175a158cde"></script>

 <script type="text/javascript" src="./main.js?3d7b071c86175a158cde"></script>


    <script>
    var appModule   =   angular.module('proto.admin');
    appModule.constant( 'CONVO_PUBLIC_API_BASE_URL', '<?php echo CONVO_PUBLIC_REST_BASE_URL ?>');
    appModule.constant( 'CONVO_ADMIN_API_BASE_URL', '<?php echo CONVO_BASE_URL ?>/rest_admin/convo/v1');

    appModule.constant( 'PROTO_ADMIN_API_BASE_URL', '<?php echo CONVO_BASE_URL ?>/rest_admin/proto/v1');
    appModule.constant( 'PROTO_PUBLIC_API_BASE_URL', '<?php echo CONVO_BASE_URL ?>/rest_public/proto/v1');
    appModule.constant( 'PROTO_HOME_CHAT_SERVICE_ID', '<?php echo PROTO_DEMO_SERVICE ?>');

    </script>

    </head>
    <body ng-controller="MainController">

	<alert-indicator></alert-indicator>

    <!-- Navigation -->
    <adm-navigation user="{{ getUserObject() }}"></adm-navigation>

    <loading-indicator></loading-indicator>

    <!-- Page Content -->
    <div class="convo-proto-content" ui-view autoscroll="false">


    </div>
    <!-- /.container -->

	<hr style="margin-top: 0">

	<footer>
		<p style="text-align: center;"><strong>Convoworks Prototype v1.17.2</strong> <br/> &copy; ZEF Development 2020
	</footer>

    </body>

</html>
